#!/usr/bin/python

from bluezhci import *
from bluezsocket import *

import os.path
import sys,os

from signal import *


#******************************************************************************************************


class bluepeerL2CAPServer:           # SERVER AND MASTER
    '''Servidor de peticiones'''

    def __init__(self):
        self.blue_sock = None
        self.incoming = []
        
        
    def serve_forever(self):
        '''Crea el server socket y se encarga de gestionar a los hijos de este'''

        #//////////////////////////////////////////////////////////////////////////////////////////////

        # Create the sever socket
        
	self.blue_sock = socket(PF_BLUETOOTH,SOCK_SEQPACKET,BTPROTO_L2CAP)

        dev_id = 0

	ba = local_device_ba(dev_id)
	
        self.blue_sock.bind((ba,9))
        #self.blue_sock.bind(("00:00:00:00:00:00",9))

        self.blue_sock.setsockopt( SOL_L2CAP, L2CAP_LM, L2CAP_LM_MASTER)
        
	self.blue_sock.listen(7)    # 7 -> numero de peticiones q puede antender

        print "Waiting connections ..."

        #//////////////////////////////////////////////////////////////////////////////////////////////
        

        while(1):
            
            connection,address = self.blue_sock.accept()

            p = os.fork()

            if p > 0:       # parent
                connection.close()
                continue
            else:       # child

                self.blue_sock.close()
                
                print "Server connected by",address[0]

                self.incoming.append(address[0])

                f = open('con.txt','a')
                f.write(address[0] + '\n')
                f.close()

                bluepeerL2CAPHandler(connection)
                connection.close()

                self.update_incoming(address[0])

                print "Diconnect from", address[0]
                print "\n"

                pid = os.getpid()            
                os.kill(pid,SIGKILL)


    def update_incoming(self,address):
        '''Actualiza el fichero de conexiones entrantes'''
        
        self.incoming.remove(address)

        f = open('con.txt','w')

        for i in self.incoming:
             f.write(i + '\n')
             
        f.close()        


#******************************************************************************************************


class bluepeerL2CAPHandler:
    '''Manejador de peticiones. Se instancia uno por cada peticion que llega y se llama al metodo handle'''

    def __init__(self, connection):

        self.connection = connection
        self.handle()

    def handle(self):
        '''Manejar una peticion entrante'''

        self.sendDeviceType()

        ret = self.sendFilesList()

        if ret == 1:
            pass
        else:
            self.sendFiles()


    def sendDeviceType(self):
        '''Envia su tipo de dispositivo al cliente'''

        dev_id = 0
        type = local_device_type(dev_id)

        self.connection.send(type)
        self.connection.send("END_TYPE")
        

    def sendFilesList(self):
        '''Envia la lista de ficheros disponibles'''
            
        lista_ficheros = os.listdir('./data/outgoing/')

        contador  = 0

        for i in lista_ficheros:
            contador = contador + 1
            self.connection.send(i)

        if contador > 0:   
            self.connection.send("FIN")
        else:
            self.connection.send("EMPTY")
            return 1      


    def sendFiles(self):
        '''Envia los ficheros disponibles'''

        while(1):

            data = self.connection.recv(512)

            if data == "SOCKET_CLOSED":
                break
                
            f = open('./data/outgoing/' + data,'r')                
            print "\nSending data ..."
                
            while 1:
                data = f.read(512)
                if not data: break		
                self.connection.send(data)

            self.connection.send("FIN")
            f.close()



        
    	
    







